---
title: 'ARIA: heading role'
slug: Web/Accessibility/ARIA/Roles/heading_role
tags:
  - ARIA
  - ARIA Role
  - ARIA heading
  - Reference
---
<div> {{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p><span class="seoSummary">The heading role defines this element as a heading to a page or section. To give the page more structure, a level should also be provided to indicate relationships between sections.</span></p>

<pre class="brush: html">&lt;div role="heading" aria-level="1"&gt;This is a main page heading&lt;/div&gt;
</pre>

<p>This defines the text in the <code>div</code> to be the main heading of the page, indicated by being level 1 via the aria-level attribute.</p>

<h2 id="Description">Description</h2>

<p>The heading role indicates to assistive technologies that this element should be treated like a heading. Screen readers would read the text and indicate that it is formatted like a heading. In addition, the level tells assistive technologies which part of the page structure this heading represents. A level 1 heading usually indicates the main heading of a page, a level 2 heading the first subsection, a level 3 is a subsection of that, and so on.</p>

<h3 id="Associated_WAI-ARIA_roles_states_and_properties">Associated WAI-ARIA roles, states, and properties</h3>

<dl>
 <dt>aria-level</dt>
 <dd>The aria-level attribute specifies the heading level in the document structure. If no level is present, a value of 2 is the default.</dd>
</dl>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<p>This role does not require any special keyboard navigation. As with any heading, giving it an ID ensures it can be referenced from anchor links, making it accessible via the keyboard.</p>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<dl>
 <dt>Required event handlers</dt>
 <dd>None.</dd>
 <dt>Changing attribute values</dt>
 <dd>Usually not required, unless dynamically inserting content. In that case, the newly-added headings need aria-level attributes whose values are consistent with the rest of the document structure.</dd>
</dl>

<div class="note">
<p><span class="ILfuVd yZ8quc">Instead of using a <code>&lt;div&gt;</code> or <code>&lt;span&gt;</code> with a <code>heading</code> role and <code>aria-level</code>, consider using a native <code>&lt;h1&gt;</code> through <code>&lt;h6&gt;</code> element instead to indicate that this text is a heading, and what part of the structure it represents.</span></p>
</div>

<h2 id="Examples">Examples</h2>

<p>The following shows a typical page structure.</p>

<pre class="brush: html">&lt;div id="container"&gt;
&lt;div role="heading" aria-level="1"&gt;The main page heading&lt;/div&gt;
&lt;p&gt;This article is about showing a page structure.&lt;/p&gt;
&lt;div role="heading" aria-level="2"&gt;Introduction&lt;/div&gt;
&lt;p&gt;An introductory text.&lt;/p&gt;
&lt;div role="heading" aria-level="2"&gt;Chapter 1&lt;/div&gt;
&lt;p&gt;Text&lt;/p&gt;
&lt;div role="heading" aria-level="3"&gt;Chapter 1.1&lt;/div&gt;
&lt;p&gt;More text in a sub section.&lt;/p&gt;
...&lt;/div&gt;</pre>

<p>However, instead, you should do:</p>

<pre class="brush: html">&lt;div id="container"&gt;
&lt;h1&gt;The main page heading&lt;/h1&gt;
&lt;p&gt;This article is about showing a page structure.&lt;/p&gt;
&lt;h2&gt;Introduction&lt;/h2&gt;
&lt;p&gt;An introductory text.&lt;/p&gt;
&lt;h2&gt;Chapter 1&lt;/h2&gt;
&lt;p&gt;Text&lt;/p&gt;
&lt;h3&gt;Chapter 1.1&lt;/h3&gt;
&lt;p&gt;More text in a sub section.&lt;/p&gt;
...&lt;/div&gt;</pre>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>If you must use the <code>heading</code> role and <code>aria-level</code> attribute, do not go over level 6 so that you are consistent with HTML. Although theoretically you can go higher, and some screen readers may support it, the results can be unpredictable with other browser/screen reader combinations.</p>

<h2 id="Best_practices">Best practices</h2>

<p>The best way to use this role is to not use it at all, and instead use the native heading tags <code>&lt;h1&gt;</code> through <code>&lt;h6&gt;</code> as shown in the example above. The <code>heading</code> role and <code>aria-level</code> attribute should only be used to retrofit accessibility on legacy code that you cannot make major changes to.</p>

<h3 id="Added_benefits">Added benefits</h3>

<p>None.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#heading","heading")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Precedence_order">Precedence order</h2>

<p>The heading role overrides the native semantic meaning of the element it is being used for. The <code>aria-level</code> attribute, in addition, determines what level of heading is being exposed.</p>

<h2 id="Screen_reader_support">Screen reader support</h2>

<p>TBD</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTML/Element/Heading_Elements">&lt;h1&gt; thru &lt;h6&gt;: The HTML Section Heading elements</a></li>
</ul>
